/*
 * @(#)CoreInfo.java   05.06.1999
 */

package corewar;


import java.io.Serializable;

/**
 * Die Klasse enthlt die Informationen ber einen Core.
 *
 * @author Hendrick Kay
 */
public class CoreInfo implements Serializable, Cloneable {

    /** Name des Cores */
    public String coreName;

    /** Name des Autors */
    public String author;

    /** Gre des Cores in Bytes */
    public short size;

    /** Objectcode des Cores */
    public byte[] core;

    /** Anpassungsvektor fr absolute Adressen im Objektcode */
    public int[] reloc;

    /** true, wenn der Core noch aktiv ist */
    public boolean alive;
    
    public CoreInfo createCopy() {
        try {
            return (CoreInfo) clone();
        } catch (CloneNotSupportedException e) {
            return null;
        }
    }
}
