/*
 * @(#)GameInfo.java   05.06.1999
 */

package corewar;

import java.io.Serializable;

/**
 * Die Klasse GameInfo enthlt die Parameter und Statusinformationen fr
 * ein CoreWar-Spiel
 *
 * @author Hendrick Kay
 */
public class GameInfo extends ParamInfo {

    /** @serial Die aktuelle Rundennummer */
    private byte roundNumber;

    /** @serial Die aktuelle Zyklennummer */
    private int cycleNumber;

    /** @serial Die Anzahl noch lebender Cores */
    private byte activeCores;

    /** @serial Der Name des Servers */
    private String serverName;


    /**
     * Erstellt eine Kopie des Objekts.
     *
     * @return Eine Kopie des Objekts.
     */
   public GameInfo createCopy() {
       try {
           return (GameInfo) clone();
       } catch (CloneNotSupportedException e) {
           return null;
       }
/*        GameInfo gi = new GameInfo();
        gi.roundNumber = roundNumber;
        gi.cycleNumber = cycleNumber;
        gi.activeCores = activeCores;
        if ( serverName != null) {
            gi.serverName = new String(serverName);
        }
        return gi;*/
   }

    /**
     * Setzt die aktuelle Rundennummer.
     *
     * @param round  Die neue aktuelle Rundennummer.
     */
    public void setRoundNumber(byte round) {
        roundNumber = round;
    }

    /**
     * Liefert die aktuelle Rundennummer.
     *
     * @return Die aktuelle Rundennummer.
     */
    public byte getRoundNumber() {
        return roundNumber;
    }

    /**
     * Setzt die aktuelle Zyklennummer.
     *
     * @param cycle  Die neue aktuelle Zyklennummer.
     */
    public void setCycleNumber(int cycle) {
        cycleNumber = cycle;
    }

    /**
     * Liefert die aktuelle Zyklennummer.
     *
     * @return Die aktuelle Zyklennummer.
     */
    public int getCycleNumber() {
        return cycleNumber;
    }

    /**
     * Setzt die Anzahl der noch lebenden Cores.
     *
     * @param cores  Die neue Anzahl der noch lebenden Cores.
     */
    public void setActiveCores(byte cores) {
        activeCores = cores;
    }

    /**
     * Liefert die Anzahl der noch lebenden Cores.
     *
     * @return Die Anzahl der noch lebenden Cores.
     */
    public byte getActiveCores() {
        return activeCores;
    }

    /**
     * Setzt den Namen des Servers.
     *
     * @param Der neue Name des Servers.
     */
    public void setServerName(String name) {
        serverName = name;
    }

    /**
     * Liefert den Namen des Serves.
     *
     * @return Der Name des Servers.
     */
    public String getServerName() {
        return serverName;
    }


}
