/*
 * @(#)GameSetupInfo.java   05.06.1999
 */
 
package corewar;

import corewar.*;

import java.io.Serializable;
import java.util.Vector;

/**
 * Die Klasse GameSetupInfo beschreibt die Einstellungen und Cores fr ein
 * Core-War-Spiel.
 *
 * @author  Hendrick Kay
 */
public class GameSetupInfo implements Serializable {
 
     /** @serial Parameter des Spiels */
     public ParamInfo paramInfo;

     /** @serial Vector von CoreInfo-Objekten */
     public Vector cores;

     /** @serial Index auf den eigenen Core in cores */
     public byte selfIndex;

     /**
      * constructor
      *
      * @param paramInfo  ParamInfo-Objekt
      * @param cores      Vector von CoreInfo-Objekten
      * @param selfIndex  byte-index auf den eigenen Core;
      */
     public GameSetupInfo(ParamInfo paramInfo, Vector cores, byte selfIndex) {
        this.paramInfo = paramInfo;
        this.cores     = cores;
        this.selfIndex = selfIndex;
     }
}