/*
 * @(#)ParamInfo.java   05.06.1999
 */

package corewar;

import java.io.Serializable;

/**
 * Die Klasse ParamInfo enthlt die Spielparameter fr ein CoreWar-Spiel
 *
 * @author Hendrick Kay
 */
public class ParamInfo implements Serializable, Cloneable {

    /** @serial Anzahl der Runden */
    private byte totalRounds;

    /** @serial Anzahl der Zyklen */
    private int maxCycles;

    /** @serial Gre des Speichers */
    private int ramSize;

    /** @serial maximale Gre der Cores */
    private short maxCoreSize;

    /** @serial Anzahl der Cores */
    private byte coreNumber;

    /** @serial minimaler Abstand zwischen 2 Cores */
    private short minDistance;

    /**
     * Setzt die Anzahl der Runden.
     *
     * @param rounds  Die neue Anzahl der Runden.
     */
    public void setTotalRounds(byte rounds) {
        totalRounds = rounds;
    }

    /**
     * Liefert die Anzahl der Runden.
     *
     * @return Die Anzahl der Runden.
     */
    public byte getTotalRounds() {
        return totalRounds;
    }

    /**
     * Setzt die Anzahl der maximalen Zyklen.
     *
     * @param cycles  Die neue Anzahl von Zyklen.
     */
    public void setMaxCycles(int cycles) {
        maxCycles = cycles;
    }

    /**
     * Liefert die Anzahl der maximalen Zyklen.
     *
     * @return Die Anzahl der maximalen Zyklen.
     */
    public int getMaxCycles() {
        return maxCycles;
    }

    /**
     * Setzt die Gre des Speichers.
     *
     * @param  size  Die neue Gre des Speichers.
     */
    public void setRAMSize(int size) {
        ramSize = size;
    }

    /**
     * Liefert die Gre des Speichers.
     *
     * @return Die Gre des Speichers.
     */
    public int getRAMSize() {
        return ramSize;
    }

    /**
     * Setzt die maximale Gre der Cores.
     *
     * @param size  Die neue maximale Gre der Cores.
     */
    public void setMaxCoreSize(short size) {
        maxCoreSize = size;
    }

    /**
     * Liefert die maximale Gre der Cores.
     *
     * @return Die maximale Gre der Cores.
     */
    public short getMaxCoreSize() {
        return maxCoreSize;
    }

    /**
     * Setzt die Anzahl der Cores.
     *
     * @param coreNumber  Neue Anzahl von Cores.
     */
    public void setCoreNumber(byte coreNumber) {
        this.coreNumber = coreNumber;
    }

    /**
     * Liefert die Anzahl der Cores.
     *
     * @return Die Anzahl der Cores.
     */
    public byte getCoreNumber() {
        return coreNumber;
    }

    /**
     * Setzt den minmalen Abstand zwischen 2 Cores.
     *
     * @param distance  Der neue minimale Abstand zwischen 2 Cores.
     */
    public void setMinDistance(short distance) {
        minDistance = distance;
    }

    /**
     * Liefert den minimalen Abstand zwischen 2 Cores.
     *
     * @return Der minimale Abstand zwischen 2 Cores.
     */
    public short getMinDistance() {
        return minDistance;
    }
}