/*
 * @(#)ServerInfo.java   08.06.1999
 */
 
package corewar;

import java.io.Serializable;
import java.net.InetAddress;

/**
 * Die Klasse beschreibt Anmeldeinformationen,
 * die der Client zum Anmelden bei einem Server
 * benoetigt.
 *
 * @author Burkhard Moser
 */

public class ServerInfo implements Serializable
{
    /** @serial  Internetadresse des Servers */
    public InetAddress address;
    
    /** @serial  Portnummer des Servers */
    public int port;
    
    /**
    * @serial  Die dem Client zugewiesene Identifikationsnummer
    *          fr die Anmeldung beim Server */
    public byte id;


    /**
     * Erzeugt ein ServerInfo-Objekt.
     * 
     * @param address  Internetadresse des Servers.
     * @param port  Portnummer des Servers.
     * @param id  Identifikationsnummer fr die Anmeldung beim Server.
     */
    public ServerInfo(InetAddress address, int port, byte id)
    {
      this.address = address;
      this.port = port;
      this.id = id;
    }
}

