/*



 * @(#)Compiler.java    20.06.1999



 */





/*



 * Diese Klasse erzeugt aus einer Quelltextdatei ein CoreInfo-Objekt,



 * welches den Objektcode eines Cores enthlt.



 * @author Benjamin Stehr



 */





package corewar.compiler;

import corewar.CoreInfo;
import java.io.*;



public class Compiler {

    Scanner scanner;

    Parser parser;

    Coder coder;

    CoreInfo Core;

    FileInputStream in;

    ParsedLine pline;





    /** Initialisiert den Compiler; IOException bei ܚbergabe eines ungltigen Files */



    public Compiler (File file) throws IOException {

        in = new FileInputStream(file);

        Core = new CoreInfo();
	 

       /** Standartmig wird der Dateiname als Corename verwendet*/

        Core.coreName=file.getName();
        Core.author="";	
	
        scanner = new Scanner (in, Core);

        parser = new Parser();

        coder = new Coder();

    }











    /** Erzeugt aus der Quelltextdatei das CoreInfo-Objekt. Wenn der Quelltext


    *   Fehler enthlt, wird eine CompilerException erzeugt. Fehler whrend des


    *   Dateizugriffs fhren zu einer IOExceptiion


    */



    public CoreInfo compile() throws IOException, CompilerException{

        ParsedLine pLine=null;

        try {

            while (scanner.hasMoreLines()) {

                pLine=parser.parseLine (scanner.nextLine());

                coder.codeLine (pLine);

            }

	if (!parser.parseComplete()) {
	        throw new CompilerException ("END erwartet");
	    }
            coder.writeCode (Core);

        }

        catch (CompilerException E) {

            throw new CompilerException (E +"  Zeile " +scanner.getLineNumber());

        }

                
                /** Ein Core, der keine Befehle enthlt, wre gem EBNF zwar zulssig, kann aber spter

                 *   keine Startposition zugewiesen bekommen. */


	if (Core.size==0) throw new CompilerException ("Mindestens ein Befehl erforderlich.");		 
	 
        return Core;

    }


}

