/*



 * @(#)ParsedLine.java    20.06.1999



 */





/*



 * Diese Klasse reprsentiert eine Zeile des Quellcodes, welche bereits

 

 * im Parser auf Gltigkeit berprft wurde.



 * @author Benjamin Stehr



 */






package corewar.compiler;

public class ParsedLine {





    /** Konstante, die benutzt wird, wenn in dieser Zeile nur ein <value> stand */



    public static final int OP_VALUE=18;







    /** */



    public static final int OP_NOTHING=1;







    /** Konstanten fr den Befehl der Zeile*/



    public static final int OP_ADD=2;    

    public static final int OP_AND=3;    

    public static final int OP_BOZ=4;    

    public static final int OP_JMN=5; 

    public static final int OP_JMP=6;

    public static final int OP_JMZ=7; 

    public static final int OP_MMR=8;

    public static final int OP_MOH=9;

    public static final int OP_MOV=10;

    public static final int OP_MUL=11;

    public static final int OP_NEG=12;

    public static final int OP_SIC=13;

    public static final int OP_SLL=14;

    public static final int OP_SRL=15;

    public static final int OP_SUB=16;

    public static final int OP_XOR=17;







    /** Name des Labels, mit dem diese Zeile begonnen hat.



     *  Ist null, falls kein Label eingegeben wurde.



     */



    public String   label;







    /** Operation, welche mit den beiden Operanden durchgefhrt werden soll */



    public int      operation;







    /** Erster Operand */



    public Operand  operandA;







    /** Zweiter Operand */



    public Operand  operandB;







    /** Enthlt den offset, welcher in dieser Zeile eingegeben wurde*/



    public byte     offset;







    /** Wird bentigt, um unterscheiden zu knnen, ob 0 fr den offset



     *  eingegeben wurde, oder ob keiner vorhanden war.



     */



    public boolean  offsetFound;







    /** Enthlt den value, welcher in dieser Zeile eingegeben wurde*/



    public int      value;

}

