/*



 * @(#)Parser.java    20.06.1999



 */





/*



 * Diese Klasse fhrt die syntaktische Analyse einer Tokenzeile durch.


 * 


 * @author Benjamin Stehr



 */

package corewar.compiler;


import java.util.Vector;



public class Parser {


    /** Es wurde noch kein BGN im Quelltext gelesen*/

    private static final byte preBGN=0;



   /** Es wurde bereits ein BGN gelesen, aber noch kein END*/


    private static final byte preEND=1;




  /** Der Quelltext wurde bereits mit END abgeschlossen. */

    private  static final byte postEND=2;


/** Ist true, wenn der Quelltext mit END beendet wurde. */


    private boolean parseComplete=false;




/** Erforderlich, um den Syntax fr BGN und END zu berprfen*/

    private byte status=preBGN;



/** Zhler, der angibt an welcher Position des Vektors sich der Parser gerade befindet*/

    private int actualElement=0;



/** Wird bentigt um festzustellen, ob der eingegebene Offset negativ war*/

    private boolean offsetIsNegative;



    private Vector v;

    private ParsedLine p;







    /** Erzeugt aus einem Vektor, der die Token einer Zeile enthlt, ein
    
    *   ParsedLine-Objekt. Tritt whrend der Analyse ein Fehler auf, so wird eine
    
    *   CompilerEception erzeugt
    
    */
        
   public ParsedLine parseLine (Vector vector) throws CompilerException {


        p= new ParsedLine();

        p.operandA=null;

        p.operandB=null;

        p.offsetFound=false;

        v=vector;

        actualElement=0;

        offsetIsNegative=false;

        boolean beginsWithLabel=false;

        boolean beginsWithValue=false;

        boolean beginsWithOperation=false;



/** ܚberprfung, ob der Syntax fr BGN und END korrekt ist. **/



        if (getContent (actualElement).equals ("BGN")) {

            if (hasMoreElements()) {

                actualElement++;

                if (getContent (actualElement).equals(";")) {

                    checkIfOnlyCommentIsLeft();

                }

                else throw new CompilerException ("ungltiges Zeichen nach BGN");

            }

            if (status==preBGN) status=preEND;
            else {
                 if (status==preEND) throw new CompilerException ("'END' erwartet");
                 else throw new CompilerException ("BGN erwartet");
            }
            
            return p;
        }



        if ((status==postEND) && (!v.isEmpty())) {

            throw new CompilerException ("Anweisung nach 'END'");

        }



        if (getContent (actualElement).equals ("END")) {

            if (status==preEND) {
	        status=postEND; 
		parseComplete=true; 
		return p;
	    }	
            else {throw new CompilerException ("'END' vor 'BGN'");}

        }



// Analyse, ob es sich um ein gltiges Statement handelt//



        if (isLabel ((Token) v.elementAt(actualElement))) {

            beginsWithLabel=true;

            nextElement ("':' nach Label erwaret");

            if (getContent (actualElement).equals(":")) {

                p.label=getContent (actualElement-1);}

                else {throw new CompilerException ("':' nach Label erwartet");

            }

            if (!hasMoreElements()) {return p;} else actualElement++;

        }



// Zeile besteht nur aus Label + Kommentar

        if (getContent (actualElement).equals(";")) {

            beginsWithLabel=true;            

            checkIfOnlyCommentIsLeft();

            return p;

        }



// Statement beginnt nicht mit einem Label aber mit einem Value

        if (isValue ((Token) v.elementAt(actualElement))) {

            beginsWithValue=true;

            p.value=Integer.parseInt (getContent (actualElement));

            p.operation=ParsedLine.OP_VALUE;

            if (hasMoreElements()) { actualElement++;

               checkIfOnlyCommentIsLeft();

            }

            return p;

        }



// Statement beginnt mit Operation oder Label + Operation

         if (isOpcode ((Token) v.elementAt(actualElement))) {

             beginsWithOperation=true;

             p.operation=getOpcode (getContent (actualElement));

             nextElement ("<Operand> nach <Opcode> erwartet");

             p.operandA=new Operand();

             isOperand ('A');

             if (hasMoreElements()) {

                 actualElement++;



                 // nach OperandA drfen nur die Zeichen , ( ; folgen

                 if (!(getContent (actualElement).equals(",")) &&

                    (!getContent (actualElement).equals("(")) &&

                    (!getContent (actualElement).equals(";"))) {

                    throw new CompilerException ("ungltiges Zeichen nach <Operand>");

                 }



                 if (getContent (actualElement).equals(";")) {

                     if (hasMoreElements()) {

                         checkIfOnlyCommentIsLeft();

                     }

                     return p;

                 }

// Offset aber keinen zweiten Operanden

                 if (getContent (actualElement).equals("(")) {

                    checkForOffset ();

                 }



// falls ein weiterer Operand folgt

                 if (getContent (actualElement).equals(",")) {

                     nextElement ("<Operand> nach ',' erwartet");

                     p.operandB=new Operand();

                     isOperand('B');

                     if (hasMoreElements()) actualElement++; else return p;



                     //nach zweitem Operanden drfen nur ( oder ; folgen



                     if ((!getContent (actualElement).equals("(")) &&

                     (!getContent (actualElement).equals(";"))) {

                         throw new CompilerException ("ungltiges Zeichen nach zweitem <Operand>");

                     }



                     if (getContent (actualElement).equals("(")) {

                         checkForOffset();

                         if (hasMoreElements()) checkIfOnlyCommentIsLeft();

                         return p;

                     }

                     else {

                         if (hasMoreElements()) checkIfOnlyCommentIsLeft();

                         return p;

                     }

                 }

             }

             else return p; //falls nach Operand 1 nichts mehr kommt

         }

         if ((!beginsWithOperation) && (!beginsWithValue)){

             throw new CompilerException 
                 ("ungltiger Zeilenanfang: Zeile mu mit <Value>, <Label> oder <Operand> beginnen");
         }

    return p;

    }





    /**  Ermglicht die externe Abfrage, ob der Quelltext korrekt abgeschlossen wurde.
     */


    public boolean parseComplete() {

        return parseComplete;

    }






    /* berprft, ob es sich bei den nchsten Elementen des vectors v
    
     * um einen gltigen Operanden handelt und fgt ggf. alle Informationen ber
     
     * diesen Operanden dem ParsedLine-Objekt hinzu.
     
     * Der Parameter gibt an, ob es sich um OperandA oder OperandB handeln soll.

     */

    private void isOperand (char c) throws CompilerException{

        boolean validBeginning = false;



// Operand beginnt mit einer Adresse

        if (isAdress ((Token) v.elementAt(actualElement))) {

            validBeginning=true;

            if (c=='A') {

                p.operandA.address=Integer.parseInt (getContent(actualElement));

                p.operandA.addressMode=Operand.MODE_DIRECT;

            }

            if (c=='B') {

                p.operandB.address=Integer.parseInt (getContent(actualElement));

                p.operandB.addressMode=Operand.MODE_DIRECT;

            }

        }





        // Operand beginnt mit einem Hash-Zeichen

        if (getContent (actualElement).equals("#")) {

            validBeginning=true;

            nextElement ("<Adress> nach '#' erwartet");

            if (isAdress ((Token) v.elementAt(actualElement))) {

                if (c=='A') {

                    p.operandA.address=Integer.parseInt (getContent(actualElement));

                    p.operandA.addressMode=Operand.MODE_CONSTANT;

                }

                if (c=='B') {

                    p.operandB.address=Integer.parseInt (getContent(actualElement));

                    p.operandB.addressMode=Operand.MODE_CONSTANT;

                }

            }

            else {throw new CompilerException ("<Address> nach '#' erwartet"); }

         }



// Operand beginnt mit einem Label



         if (isLabel ((Token) v.elementAt(actualElement))) {

             validBeginning=true;

             if (c=='A') {

                 p.operandA.label=getContent (actualElement);

                 p.operandA.addressMode=Operand.MODE_DIRECT;

             }

             if (c=='B') {

                 p.operandB.label=getContent (actualElement);

                 p.operandB.addressMode=Operand.MODE_DIRECT;

             }

             if (hasMoreElements()) {

                 actualElement++;

                 if (getContent (actualElement).equals("+")) {

                     nextElement ("<Distance> nach '+' erwartet");

                     if (isDistance ((Token) v.elementAt(actualElement))) {

                         if (c=='A') {

                             p.operandA.distance=Short.parseShort (getContent (actualElement));

                         }

                         if (c=='B') {

                             p.operandB.distance=Short.parseShort (getContent (actualElement));

                         }

                     }

                     else {throw new CompilerException ("ungltige <Distance>");}

                 }





                 if (getContent (actualElement).equals("-")) {    

                     nextElement ("<Distance> nach '-' erwartet");

                     if (isDistance ((Token) v.elementAt(actualElement))) {

                         if (c=='A') {

                             p.operandA.distance=Short.parseShort (getContent (actualElement));

                             p.operandA.distance= (short) -p.operandA.distance;

                         }

                         if (c=='B') {

                             p.operandB.distance=Short.parseShort (getContent (actualElement));

                             p.operandB.distance= (short) -p.operandA.distance;

                         }



                     }

                     else {throw new CompilerException ("ungltige Distanz");}

                 }



                 if (((!getContent (actualElement-1).equals("+")) &&

                    (!getContent (actualElement-1).equals("-")))) {

                        actualElement--;

                 }

             }

         }





// Operand beginnt mit einem At-Zeichen

         if (getContent (actualElement).equals("@")) {

             validBeginning=true;

             nextElement ("<Label> oder <Address> nach '@' erwartet");



             //Fehlermeldung, falls weder Adresse noch Label



             if ((!isAdress ((Token) v.elementAt(actualElement))) &&

                 (!isLabel ((Token) v.elementAt(actualElement)))){

                     throw new CompilerException ("<Address> oder <Label> nach '@' erwartet");

             }



             if (isAdress ((Token) v.elementAt(actualElement))) {

                 if (c=='A') {

                     p.operandA.address=Integer.parseInt (getContent(actualElement));

                     p.operandA.addressMode=Operand.MODE_INDIRECT;

                 }

                 if (c=='B') {

                     p.operandB.address=Integer.parseInt (getContent(actualElement));

                     p.operandB.addressMode=Operand.MODE_INDIRECT;

                 }



             }

             if (isLabel ((Token) v.elementAt(actualElement))) {



                 if (c=='A') {

                     p.operandA.label=getContent (actualElement);

                     p.operandA.addressMode=Operand.MODE_INDIRECT;

                 }

                 if (c=='B') {

                     p.operandB.label=getContent (actualElement);

                     p.operandB.addressMode=Operand.MODE_INDIRECT;

                 }



                 if (hasMoreElements()) {



                     actualElement++;



                     if (getContent (actualElement).equals("+")) {

                         nextElement ("<Distance> nach '+' erwartet");

                         if (isDistance ((Token) v.elementAt(actualElement))) {

                             if (c=='A') {

                                 p.operandA.distance=Short.parseShort (getContent (actualElement));

                             }

                             if (c=='B') {

                                 p.operandB.distance=Short.parseShort (getContent (actualElement));

                             }

                         }

                         else {throw new CompilerException ("ungltige <Distance>");}
                     }

                   



                     if (getContent (actualElement).equals("-")) {    

                         nextElement ("Distance nach '-' erwartet");

                         if (isDistance ((Token) v.elementAt(actualElement))) {

                             if (c=='A') {

                                 p.operandA.distance=Short.parseShort (getContent (actualElement));

                                 p.operandA.distance= (short) -p.operandA.distance;

                             }

                             if (c=='B') {

                                 p.operandB.distance=Short.parseShort (getContent (actualElement));

                                 p.operandB.distance= (short) -p.operandA.distance;

                             }

                         }

                         else {throw new CompilerException ("ungltige <Distance>");}

                     }



                     if (((!getContent (actualElement-1).equals("+")) &&

                        (!getContent (actualElement-1).equals("-")))) {

                            actualElement--;

                     }



                 } 

             }

         }



         if (!validBeginning) {

             throw new CompilerException ("<Operand> mu mit '#' / '@' / <Label> / <Address> beginnen.");
         }

    }






  /** berprft, ob die nchsten Elemente des Vektors v einen korrekt geklammerten
     
    * und gltigen Offset bilden.

    * Sollte dies der Fall sein, werden die entspechenden Daten in das
    
    * ParsedLine-Objekt p geschrieben.

    * Falls nicht. wird eine CompilerException erzeugt. Die Methode darf also nur
    
    * aufgerufen werden, wenn ein Offset folgen mu.

    */



    private void checkForOffset () throws CompilerException {



        nextElement ("<Offset> erwartet");

        if (getContent (actualElement).equals("+")) {

            nextElement ("<Offset> erwartet");

        }

        if (getContent (actualElement).equals("-")) {

            nextElement ("<Offset> erwaret");

            offsetIsNegative=true;

        }

        if (isOffset ((Token) v.elementAt(actualElement))) {

            if (offsetIsNegative) {

                p.offset=Byte.parseByte (getContent (actualElement));

                p.offset=(byte) -p.offset;

                p.offsetFound=true;

            }

            else {

                p.offset=Byte.parseByte (getContent (actualElement));

                p.offsetFound=true;

            }

        }

        else {throw new CompilerException ("ungltiger <Offset>");}

        nextElement ("')' erwartet");

        if (!getContent (actualElement).equals(")")) {

            throw new CompilerException ("ungltiges Zeichen nach <Offet>, ( ')' erwartet)");

        }



        // nach einem Offset darf nur noch Kommentar kommen

        if (hasMoreElements()) {

            actualElement++;

            checkIfOnlyCommentIsLeft();

        }

    }






   /**  berprft, ob der Inhalt des Token t alle Bedingungen fr ein gltiges
   
     *  Label erfllt.

     *  Opcodes, BGN und END sind nicht zugelassen, da es sich um reservierte
     
     *Wrter handelt

     */


    private boolean isLabel (Token t) {



        for (int i=1; i+1<=t.content.length(); i++) {

            if (!Character.isLetterOrDigit (t.content.charAt(i)) ) return false;

        }



        if (isOpcode (t)) {return false;}

        if ((t.content.equals("BGN")) || (t.content.equals("END"))) return false;

        if ((t.content==null) || (t.content.length() > 4)

            || (!Character.isLetter (t.content.charAt(0)) )) {

                return false;

            }



        return true;

    }





    /**  berprft, ob es sich bei dem Inhalt des Token t um einen gltigen Opcode
    
      *  handelt.
      
      */



    private boolean isOpcode (Token t) {

        if (t.content.equals("ADD")) return true;

        if (t.content.equals("AND")) return true;

        if (t.content.equals("BOZ")) return true;

        if (t.content.equals("JMN")) return true;

        if (t.content.equals("JMP")) return true;

        if (t.content.equals("JMZ")) return true;

        if (t.content.equals("MMR")) return true;

        if (t.content.equals("MOH")) return true;

        if (t.content.equals("MOV")) return true;

        if (t.content.equals("MUL")) return true;

        if (t.content.equals("NEG")) return true;

        if (t.content.equals("SIC")) return true;

        if (t.content.equals("SLL")) return true;

        if (t.content.equals("SRL")) return true;

        if (t.content.equals("SUB")) return true;

        if (t.content.equals("XOR")) return true;



        return false;

    }





    /* Liefert eine dem Befehl entspechende Kontante zurck, die in der Klasse

     * ParsedLine definiert wurde.

      */

    private int getOpcode (String s) {

        if (s.equals("ADD")) return ParsedLine.OP_ADD;

        if (s.equals("AND")) return ParsedLine.OP_AND;

        if (s.equals("BOZ")) return ParsedLine.OP_BOZ;

        if (s.equals("JMN")) return ParsedLine.OP_JMN;

        if (s.equals("JMP")) return ParsedLine.OP_JMP;

        if (s.equals("JMZ")) return ParsedLine.OP_JMZ;

        if (s.equals("MMR")) return ParsedLine.OP_MMR;

        if (s.equals("MOH")) return ParsedLine.OP_MOH;

        if (s.equals("MOV")) return ParsedLine.OP_MOV;

        if (s.equals("MUL")) return ParsedLine.OP_MUL;

        if (s.equals("NEG")) return ParsedLine.OP_NEG;

        if (s.equals("SIC")) return ParsedLine.OP_SIC;

        if (s.equals("SLL")) return ParsedLine.OP_SLL;

        if (s.equals("SRL")) return ParsedLine.OP_SRL;

        if (s.equals("SUB")) return ParsedLine.OP_SUB;

        if (s.equals("XOR")) return ParsedLine.OP_XOR;

        return (ParsedLine.OP_NOTHING);

    }






    /**  berprft, ob es sich bei dem Inhalt des Token t um einen gltigen Value
    
      *  handelt.
      
      */


    private boolean isValue (Token t) {

        int i;

        try {

            i=Integer.parseInt (t.content);

        }

        catch (NumberFormatException E) {return false;}

        if ((i<0) || (i>65535)) return false;

        return true;

    }






    /**  berprft, ob es sich bei dem Inhalt des Token t um eine gltige Adresse
    
      *  handelt.
      
      */


    private boolean isAdress (Token t) {

        if (isValue (t)) {

            return true;

        }

        return false;

    }






    /**  berprft, ob es sich bei dem Inhalt des Token t um eine gltige Distance 
    
      *  handelt.
      
      */


    private boolean isDistance (Token t) {

        short s;

        try {

            s=Short.parseShort (t.content);

        }

        catch (NumberFormatException E) {return false;}

        if ((s<0) || (s>255)) return false;

        return true;

    }




    /**  berprft, ob es sich bei dem Inhalt des Token t um einen gltigen Offset
    
      *  handelt.
      
      */



    private boolean isOffset (Token t) {

        byte b;

        try {

            b=Byte.parseByte (t.content);

        }

        catch (NumberFormatException E) {return false;}

        if ((b<0) || (b>127)) return false;

        return true;

    }




    /** berprft, ob nach der aktuellen Position nur noch gltiger Kommenar 

      * kommt. Da tatschlich einige Zeichen im Kommentar verboten sind,

      * kann nicht einfach alles, was auf ein ; folgt ignoriert werden.

      */


    private void checkIfOnlyCommentIsLeft () throws CompilerException{

        if (!getContent (actualElement).equals(";")) {

            throw new CompilerException ("Ende des Ausdrucks erwartet");

        }

        while (hasMoreElements()) {

            actualElement++;

            for (int i=0; getContent(actualElement).length()>=i+1; i++) {

                if (!Character.isLetterOrDigit (getContent (actualElement).charAt(i))) {

                    switch (getContent (actualElement).charAt (i)) {

                        case '/':

                            break;

                        case '(':

                            break;

                        case ')':

                            break;

                        case ',':

                            break;

                        case '.':

                            break;

                        case '-':

                            break;

                        case '_':

                            break;

                        case '*':

                            break;

                        default: throw new CompilerException ("ungltiges Zeichen im Kommentar");

                    }

                }

            }

        }

    }






   /** Wird verwendet um einen einfacheren Zugriff auf den Inhalt eines Token
   
     * zu ermglichen
     
     */


    private String getContent (int element) {

        Token t;

        t=(Token) v.elementAt(element);

        return t.content;

    }





 /** Inkrementiert actualElement und gibt den bergebenen String als
 
   * CompilerException aus, falls keine weiteren Elemente mehr vorhanden sind.

   */ 

    private void nextElement (String errorMessage) throws CompilerException{

        if (!hasMoreElements()) {

            throw new CompilerException (errorMessage);

        }

        else actualElement++;

    }






/* Liefert true, falls nach der aktuellen Position noch weitere Elemente im 

 * Vektor v enthalten sind 
 
 */


    private boolean hasMoreElements () {

        if (actualElement+1 < v.size()) return true;

        return false;

    }



}

