/*
 * @(#)MetaClientList.java    18.6.1999
 */


package corewar.metaserver;

import corewar.ExtendedList;
import corewar.CoreInfo;

/**
 * Die Klasse MetaClientList verwaltet eine Liste von MetaClientSocket-Objekten
 * und stellt sie visuell dar.
 *
 * @author  Ivo Kasiuk
 */
public class MetaClientList extends ExtendedList {

    /* Die Spaltentitel von links nach rechts. */
    private final static String[] titles = { "Core", "Gre" };

    /* Die Spaltenbreiten von links nach rechts. */
    private final static int[] columnWidths = { 20, 5 };

    /**
     * Erstellt eine neue Liste.
     * @param lines  Die sichtbare Hhe der Liste in Zeilen.
     */
    public MetaClientList(int lines) {
        super(lines);
    }

    /**
     * Liefert die Spaltenbreiten der Tabelle.
     * @return  Die Spaltenbreiten als Array.
     */
    public int[] getColumnWidths() {
        return columnWidths;
    }

    /**
     * Liefert die Spaltenberschriften der Tabelle.
     * @return  Die berschriften als Array.
     */
    public String[] getTitles() {
        return titles;
    }

    /**
     * Liefert die Eintrge einer Zeile.
     * @param element  Der zu dieser Zeile gehrige MetaClientSocket.
     * @return  Die Eintrge der Zeile als Array.
     */
    public String[] getEntries(Object element) {
        String[] result = new String[2];
        CoreInfo core   = ((MetaClientSocket) element).getCoreInfo();
        result[0] = core.coreName;
        result[1] = String.valueOf(core.size);
        return result;
    }
}
