/*
 * @(#)MetaClientSSocket.java    17.6.1999
 */


package corewar.metaserver;

import corewar.NetworkSSocket;
import java.io.IOException;
import java.net.Socket;

/**
 * Die Klasse MetaClientSSocket nimmt die sich anmeldenden Clients entgegen.
 *
 * @author  Ivo Kasiuk
 */
public class MetaClientSSocket extends NetworkSSocket {

    /* Der MetaServer, an den sich anmeldende Clients weitergeleitet werden. */
    private MetaServer metaServer;
    
    /**
     * Richtet einen ServerSocket ein, an dem sich Clients anmelden knnen.
     * @param metaServer  Sich anmeldende Clients werden an diesen MetaServer
     *                    weitergeleitet.
     * @param locked      true, wenn der MetaClientSSocket anfnglich gesperrt
     *                    sein soll.
     */
    public MetaClientSSocket(MetaServer metaServer, boolean locked)
            throws IOException {
        super(DEFAULT_META_CLIENT_PORT, locked);
        this.metaServer = metaServer;
    }

    /**
     * Leitet einen sich anmeldenden Client an den MetaServer weiter.
     * @param client  der sich anmeldende Client.
     */
    protected void handleConnection(Socket client) {
        try {
            metaServer.distributeClient(new MetaClientSocket(metaServer,
                                                             client));
        } catch (IOException ioe) {}
    }
}
