/*
 * @(#)MetaServerList.java    23.6.1999
 */


package corewar.metaserver;

import java.awt.event.ItemEvent;
import java.util.Vector;
import corewar.CoreInfo;

import java.net.Socket;
import java.net.InetAddress;
  
  import java.awt.Frame;
  import java.awt.event.WindowAdapter;
  import java.awt.event.WindowEvent;
  import java.awt.event.ItemListener;

/**
 * Die Klasse MetaServerList ist eine visuelle Liste, deren Elemente
 * tabellenfrmig angezeigt werden. Die Elemente sind MetaServerSocket-Objekte,
 * die mit dem Namens des Servers je eine Zeile der Tabelle stellen. Die Klasse 
 * bernimmt auch die Verwaltung der MetaServerSocket-Objekte in einem Vector, die 
 * die anzuzeigenden Informationen beinhalten.
 *
 * @author  Carsten Buschmann
 */
public class MetaServerList extends corewar.ExtendedList {
    
    /**
     * Erzeugt eine neue MetaServerList.
     * @param lines Anzahl der sichtbaren Zeilen der Liste.
     */
    public MetaServerList(int lines) {
        super(lines);
    }


    /**
     * Liefert die Spaltenbreiten der Tabelle abhngig vom breitesten Inhalt einer Spalte.
     * @return  Ein Array von Spaltenbreiten int Zeichen.
     */
    protected int[] getColumnWidths() {
      int[] result = { 15, 15 };
      return result;

    }

    /**
     * Liefert die berschriften der Spalten.
     * @return  Die berschriften fr die Spalten als Array.
     */
    protected String[] getTitles() {
                  String[] result = { "Servername", "bentigte Cores" };
                  return result;
    	
    }

    /**
     * Liefert die Eintrge fr eine Zeile.
     * @param element  Das CoreInfo-Objekt, das diese Zeile reprsentiert.
     * @return  Die Eintrge fr diese Zeile als Array.
     */
    protected String[] getEntries(Object element) {
        String[] result = new String[2];
        MetaServerSocket mss = (MetaServerSocket)element;
        Socket s = mss.getSocket();
        InetAddress addr = s.getInetAddress();
        result[0] = addr.getHostName();
        result[1] = String.valueOf(mss.getNumCoresNeeded());
        return result;
    }

 
      public static void main(String[] args) {
          MetaServerList list = new MetaServerList(10);
          Frame f = new Frame("Test MetaServerList");
          f.add(list);
          /*CoreInfo ci = new CoreInfo();
          ci.size = 1024;
          ci.author = "Theo";
          ci.coreName = "Core-nedbeef";
          ci.alive = true;
          list.addElement(ci);*/
          list.addItemListener(new ItemListener() {
              public void itemStateChanged(ItemEvent event) {
                  System.out.println(event);
              }
          });
          f.addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent event) {
                  System.exit(0);
              }
          });
          f.pack();
          f.setVisible(true);
      }
}