/*
 * @(#)CycleInfo.java   19.06.1999
 */
 
package corewar.server;


/**
 * Die Klasse enthaelt als reine Datenklasse
 * die Daten ueber einen Simulationszyklus.
 *
 * @author Burkhard Moser
 */
public class CycleInfo
{
   /** pc  Enthaelt fuer jeden Core die
    *      Stelle im Ram, an der sich sein
    *      Programmzaehler gerade befindet.*/
   public short[] pc = null;

   /** writeAddr  Enthaelt fuer jeden Core die
    *             Speicherstelle im Ram, an die er
    *             geschrieben hat, oder Null, wenn der
    *             Core nicht geschrieben hat.*/
   public short[] writeAddr = null;

   /** writeSize  Enthaelt fuer jeden Core die
    *             Anzahl an Bytes, die er geschrieben
    *             hat, oder -1, wenn der Core einen
    *             ungueltigen Befehl ausgefuehrt hat.*/
   public byte[] writeSize = null;


   /**
    * Erzeugt ein CycleInfo-Objekt. Die Groesse der Arrays wird so gewaehlt,
    * dass fuer jeden am Turnier teilnehmenden Core ein Wert in jedes Array
    * geschrieben werden kann.
    * 
    * @param size  Gibt die Anzahl der Cores an, die an dem Turnier teilnehmen.
    */
   public CycleInfo(int size)
   {
      this.pc = new short[size];
      this.writeAddr = new short[size];
      this.writeSize = new byte[size];
   }
}



