/*
 * @(#)ServerClientSSocket.java    14.6.1999
 */
package corewar.server;

import corewar.CWProtocol;
import corewar.NetworkSSocket;
import corewar.MessageBox;
import java.awt.Frame;
import java.io.IOException;
import java.net.Socket;

/**
 * Die Klasse ServerClientSSocket stellt einen Port zur verfuegung und hoert diesen
 * staendig ab. Sobald sich jemand anmeldet wird der Socket an den ClientAccepter
 * weitergegeben.
 *
 * @author  Stephan Keitz
 */
public class ServerClientSSocket extends NetworkSSocket implements CWProtocol {

  /** Referenz auf den NetManager */
  private NetManager netManager;

  /**
   * Der Konstruktor erstelt einen ServerSocket mit der Portnummer 'port' und
   * initialisiert die Referenz auf den NetManager.
   * @param nm    Referenz auf den NetManager
   * @param port  Portnummer
   * @exception IOException  Falls waehrend des Erstellen des Ports ein Fehler
   *                         auftritt.
   */
  public ServerClientSSocket(NetManager nm, int port) throws IOException {
    super(port,true);
    netManager = nm;
  }

  /**
   * Uebergibt einen neu erstellten Socket an den ClientAccepter
   * @param socket  Der neu erstellte Socket
   */
  protected void handleConnection(Socket socket) {
    ClientAccepter clientAccepter = new ClientAccepter(netManager, socket);
  }

}