/*
 * @(#)ServerCoreList.java    11.6.1999
 */


package corewar.server;

import java.awt.event.ItemEvent;
import java.util.Vector;
import corewar.CoreInfo;
  
  import java.awt.Frame;
  import java.awt.event.WindowAdapter;
  import java.awt.event.WindowEvent;
  import java.awt.event.ItemListener;

/**
 * Die Klasse ServerCoreList ist eine visuelle Liste, deren Elemente
 * tabellenfrmig angezeigt werden. Die Elemente sind CoreInfo-Objekte,
 * die je eine Zeile der Tabelle stellen. Die Klasse bernimmt auch die Verwaltung
 * der CoreInfo-Objekte in einem Vector, die die anzuzeigenden Informationen beinhalten.
 *
 * @author  Carsten Buschmann
 */
public class ServerCoreList extends corewar.ExtendedList {
    
    /**
     * Erzeugt eine neue ServerCoreList.
     * @param lines Anzahl der sichtbaren Zeilen der Liste.
     */
    public ServerCoreList(int lines) {
        super(lines);
	      //setSize( 400, 100);
        
    }


    /**
     * Liefert die Spaltenbreiten der Spalten der Tabelle
     * @return  Ein Array von Spaltenbreiten int Zeichen.
     */
    protected int[] getColumnWidths() {
      int[] result = { 15, 15, 9, 6 };
      return result;

    }

    /**
     * Liefert die berschriften der Spalten.
     * @return  Die berschriften fr die Spalten als Array von Strings
     */
    protected String[] getTitles() {
                  String[] result = { "Corename", "Spielername", "Coregre","Status" };
                  return result;
    	
    }

    /**
     * Liefert die Eintrge fr eine Zeile.
     * @param element  Das CoreInfo-Objekt, das diese Zeile reprsentiert.
     * @return  Die Eintrge fr diese Zeile als Array.
     */
    protected String[] getEntries(Object element) {
        String[] result = new String[4];
        CoreInfo ci = (CoreInfo)element;
        result[0] = ci.coreName;
        result[1] = ci.author;
        result[2] = Short.toString(ci.size);
        if (ci.alive) result[3] = "lebt"; else result[3] = "tot";
        return result;
    }

 
      public static void main(String[] args) {
          ServerCoreList list = new ServerCoreList(10);
          Frame f = new Frame("Test ServerCoreList");
          f.add(list);
          CoreInfo ci = new CoreInfo();
          ci.size = 1024;
          ci.author = "Theo";
          ci.coreName = "Core-nedbeef";
          ci.alive = true;
          list.addElement(ci);
          list.addItemListener(new ItemListener() {
              public void itemStateChanged(ItemEvent event) {
                  System.out.println(event);
              }
          });
          f.addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent event) {
                  System.exit(0);
              }
          });
          f.pack();
          f.setVisible(true);
      }
}